Bug 13416 - cleanupd sends MSG_SMB_UNLOCK twice to interested peers
cleanupd sends MSG_SMB_UNLOCK twice to interested peers
Status: RESOLVED FIXED
Product: Samba 4.1 and newer
Classification: Unclassified
Component: Clustering
unspecified
All All
: P5 normal
: ---
Assigned To: Karolin Seeger
Samba QA Contact
:
Depends on:
Blocks:
  Show dependency treegraph
 
Reported: 2018-05-01 07:55 UTC by Ralph Böhme
Modified: 2018-05-17 11:31 UTC (History)
3 users (show)

See Also:


Attachments
git-am fix for 4.8.next. (1.51 KB, patch)
2018-05-04 20:52 UTC, Jeremy Allison
slow: review+
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Ralph Böhme 2018-05-01 07:55:46 UTC
MSG_SMB_UNLOCK should be send to smbd that are waiting on blocked byte-range-locks when a lock holder died.

In smbd_cleanupd_unlock() we do this twice: once via a broadcast and then again via brl_revalidate() to processes that are actually recorded in brlock.tdb.

As brl_revalidate() should already take care of signaling anyone who would be interested in the message, there's no need to broadcast.
Comment 1 Jeremy Allison 2018-05-04 20:52:30 UTC
Created attachment 14179 [details]
git-am fix for 4.8.next.

Cherry-picked from master. I think 4.7.x also suffers from this bug, but it isn't as critical there (brl_revalidate() is idempotent).
Comment 2 Ralph Böhme 2018-05-11 06:46:51 UTC
Reassigning to Karolin for inclusion in 4.8.
Comment 3 Karolin Seeger 2018-05-14 07:51:31 UTC
(In reply to Ralph Böhme from comment #2)
Pushed to autobuild-v4-8-test.
Comment 4 Karolin Seeger 2018-05-17 11:31:11 UTC
(In reply to Karolin Seeger from comment #3)
Pushed to v4-8-test.
Closing out bug report.

Thanks!